import StringIO
import re
from genshi.core import Markup
from trac.wiki import Formatter
from trac.core import Component, implements
from trac.wiki.api import IWikiMacroProvider
from trac.web.href import Href
from trac.resource import (
    Resource, ResourceNotFound, get_resource_name, get_resource_summary,
    get_resource_url
)


import commands
class xfig(Component):
    implements(IWikiMacroProvider)

    # IWikiMacroProvider methods
    def get_macros(self):
        return ('xfig', 'XFig', 'XFIG')

    def get_macro_description(self, name):
        return 'xfig figure show'

    def expand_macro(self, formatter, name, content):
        if name.lower() == "xfig":
             out = StringIO.StringIO()
             #Formatter(self.env, formatter.context).format(self.fig2dev(content), out)
             filespec=content.split(',').pop(0)
             parts= filespec.split(':')
             url = raw_url = desc = None
             attachment = None
## process of image input format copied from macros.py ##
             if len(parts) == 3:                 # realm:id:attachment-filename
                 #                                 # or intertrac:realm:id
                  realm, id, filename = parts
                  intertrac_target = "%s:%s" % (id, filename)
                  it = formatter.get_intertrac_url(realm, intertrac_target)
                  if it:
                     url, desc = it
                     raw_url = url + unicode_quote('?format=raw')
                  else:
                     attachment = Resource(realm, id).child('attachment', filename)
             elif len(parts) == 2:
                  realm, filename = parts
                  if realm in browser_links:   # source:path
                     # TODO: use context here as well
                     rev = None
                     if '@' in filename:
                         filename, rev = filename.rsplit('@', 1)
                     url = formatter.href.browser(filename, rev=rev)
                     raw_url = formatter.href.browser(filename, rev=rev,
                                                      format='raw')
                     desc = filespec
                  else: # #ticket:attachment or WikiPage:attachment
                     # FIXME: do something generic about shorthand forms...
                     realm = None
                     id, filename = parts
                     if id and id[0] == '#':
                         realm = 'ticket'
                         id = id[1:]
                     elif id == 'htdocs':
                         raw_url = url = formatter.href.chrome('site', filename)
                         desc = os.path.basename(filename)
                     else:
                         realm = 'wiki'
                     if realm:
                         attachment = Resource(realm, id).child('attachment',
                                                           filename)
             elif len(parts) == 1: # it's an attachment of the current resource
                  
                  attachment = formatter.resource.child('attachment', filespec)
             else:
                  raise TracError('No filespec given')
             if attachment and 'ATTACHMENT_VIEW' in formatter.perm(attachment):
                  print 'here 1',self.env
                  url = get_resource_url(self.env, attachment, Href('/'))
                  #url = get_resource_url(self.env, attachment, formatter.href)
                  raw_url = get_resource_url(self.env, attachment, formatter.href,
                                            format='raw')
                  try:
                     desc = get_resource_summary(self.env, attachment)
                  except ResourceNotFound, e:
                     raw_url = formatter.href.chrome('common/attachment.png')
                     desc = _('No image "%(id)s" attached to %(parent)s',
                              id=attachment.id,
                              parent=get_resource_name(self.env, attachment.parent))
        return  self.fig2dev(url)

    def fig2dev(self, in_filename):
       in_filename=re.sub(r'^/attachment',r'/attachments',in_filename)
       filename=self.env.path+in_filename
       print self.env.path,in_filename
       svg=commands.getoutput('fig2dev -L svg %s'%filename)
       print dir(self.env)
       print 'base_url is ',self.env.base_url
       print 'project_url is ',self.env.project_url
       return svg

